#!/usr/bin/env python

from lxml.etree import parse, tostring
from os import rename, walk
from sys import argv, exit

if len(argv) != 6:
    print """De volgende vijf argumenten moeten worden meegeven:
storagedirectory domain repositoryGroup repository inbox""";
    exit()

storage         = argv[1].rstrip("/")
domain          = argv[2]
repositoryGroup = argv[3]
repository      = argv[4]
inbox           = argv[5].rstrip("/")

def makeMetadataReindex(dir):
    part = parse(dir + "/metadata")
    metadata = part.xpath("/metadata:metadata", {'metadata': "http://www.openarchives.org/OAI/2.0/"})[0]
    new = open(dir + "/metadata.reindex", "w")
    new.write(tostring(metadata[0], encoding="utf-8"))
    new.close()

tree = walk(storage + "/" + repository)
for directory in tree:
    dir = directory[0]
    for file in directory[2]:
        if file == "metadata":
            makeMetadataReindex(dir)
            id = dir.split("/")[-1]
            rename(dir + "/metadata.reindex", inbox + "/" + domain + ":" + repositoryGroup + ":" + dir.split("/")[-2] + ":" + id + ".record")
            print(id)
